<template>
  <div class="container mt-5">
    <div v-show="showOrder">
      <h2>Cadastro de Chamados</h2>
      <button class="btn btn-danger" style="height: 40px">
        <router-link
          class="nav-link"
          style="color: white; margin-top: -10px"
          to="/tecedit"
          >editar perfil</router-link
        >
      </button>
      <h4 class="mt-5">Busca de Chamados</h4>
      <div class="row">
        <div class="col-md-10">
          <input
            type="text"
            class="form-control"
            name="id"
            v-model="stringBusca"
            placeholder="id"
            required
          />
        </div>
        <div class="col-md-2">
          <a class="btn btn-warning float-right" @click="buscar(stringBusca)">
            <i class="fas fa-search"></i>buscar
          </a>
        </div>
      </div>
      <h5 class="mt-2">Chamados</h5>
      <table class="table table-striped">
        <thead>
          <tr>
            <th>ID</th>
            <th>Defeito Apresentado</th>
            <th>Defeito Relatado</th>
            <th>Valor</th>
            <th>Status</th>
          </tr>
        </thead>

        <tbody>
          <tr
            v-for="chamado in chamados"
            v-bind:key="chamado.id"
            v-bind:style="{ background: color[chamado.status] }"
          >
            <td>{{ chamado.id }}</td>
            <td>{{ chamado.defApresentado }}</td>
            <td>{{ chamado.defRelatado }}</td>
            <td>R${{ chamado.valor }}</td>
            <td>{{ convertStatus[chamado.status] }}</td>
            <td>
              <a
                data-toggle="collapse"
                href="'#' + chamado.id"
                class="btn btn-sm btn-warning mx-1"
                @click="editar(chamado.id)"
              >
                <i class="fas fa-tools" title="Alterar"></i>
              </a>
            </td>
          </tr>
        </tbody>
      </table>
    </div>
    <div v-show="showOrderRepair">
      <h3>Reparo</h3>
      <button class="btn btn-danger float-right" @click="turnBack()">
        voltar
      </button>
      <p>Valor total do chamado: R${{ chamado.valor }}</p>
      <p>Defeito Relatado: {{ chamado.defRelatado }}</p>
      <p>Status: {{ convertStatus[chamado.status] }}</p>
      <div class="panel-group">
        <div class="panel panel-default">
          <div class="card-header">
            <div class="form-group row">
              <div class="card-body">
                <form @submit.prevent="salvar">
                  <div class="form-group row">
                    <div class="col-lg-12">
                      <label>Defeito Apresentado</label>
                      <input
                        type="text"
                        class="form-control"
                        name="defApresentado"
                        ref="defApresentado"
                        v-model="chamado.defApresentado"
                        placeholder="Defeito Apresentado"
                        required
                      />
                    </div>
                  </div>
                  <div class="form-group row">
                    <div class="col-lg-12">
                      <label>Valor orçamento prévio</label>
                      <input
                        type="text"
                        class="form-control"
                        name="valorChamado"
                        v-model="orderValue"
                        placeholder="Valor orçamento prévio"
                        @input="sumOrder()"
                        required
                      />
                    </div>
                  </div>

                  <div class="form-group row">
                    <div class="col-12 border bg-white">
                      <label for="componente_id">Busca Componentes</label>
                      <div class="row">
                        <div class="col-md-10">
                          <input
                            type="text"
                            class="form-control"
                            name="desc"
                            v-model="desc"
                            placeholder="descrição"
                            required
                          />
                        </div>
                        <a
                          class="btn btn-warning float-right col-md-2"
                          @click="searchComponent(desc)"
                        >
                          <i class="fas fa-search"></i>buscar
                        </a>
                      </div>
                      <h5 class="mt-5">Componentes Adicionados</h5>
                      <table class="table table-striped">
                        <thead>
                          <tr>
                            <th>ID</th>
                            <th>descricão</th>
                            <th>valor unitário</th>
                            <th>valor total</th>
                            <th>Qtd em estoque</th>
                          </tr>
                        </thead>

                        <tbody>
                          <tr
                            v-for="componente in chamado.componentsJson"
                            v-bind:key="componente.id"
                          >
                            <td>{{ componente.id }}</td>
                            <td>{{ componente.descricao }}</td>
                            <td>R${{ componente.valor }}</td>
                            <td>R${{ componente.valorTotal }}</td>
                            <td>{{ componente.quantidade }}</td>
                            <td>
                              <input
                                type="number"
                                v-model="componente.qtd"
                                @input="sumValue(componente.qtd, componente.id)"
                                min="1"
                                :max="componente.quantidade"
                              />
                            </td>
                          </tr>
                        </tbody>
                      </table>

                      <h5 class="mt-5">Selecionar Componentes</h5>
                      <table class="table table-striped">
                        <thead>
                          <tr>
                            <th>ID</th>
                            <th>descriçao</th>
                            <th>Valor</th>
                            <th>Qtd estoque</th>
                          </tr>
                        </thead>

                        <tbody>
                          <tr
                            v-for="componente in componentes"
                            v-bind:key="componente.id"
                          >
                            <td>{{ componente.id }}</td>
                            <td>{{ componente.descricao }}</td>
                            <td>R${{ componente.valorComponente }}</td>
                            <td>{{ componente.quantidade }}</td>
                            <td>
                              <a
                                data-toggle="collapse"
                                href="'#' + produto.id"
                                class="btn btn-sm btn-primary mx-1"
                                @click="addComponent(componente.id)"
                              >
                                <i class="fas fa-plus" title="adicionar"></i>
                              </a>
                            </td>
                          </tr>
                        </tbody>
                      </table>
                    </div>
                  </div>
                  <a
                  v-show="btnOr[chamado.status]"
                    type="submit"
                    class="btn btn-success text-white float-right text-white"
                    value="Salvar"
                    @click="salvar()"
                  >
                    <p ><i  class="fas fa-tools"></i> Orçar</p>
                  </a>
                  <a
                  v-show="btnFin[chamado.status]"
                    type="submit"
                    class="btn btn-success text-white float-right text-white"
                    value="Salvar"
                    @click="salvar()"
                  >
                    <p ><i  class="fas fa-tools"></i> Finalizar</p>
                  </a>
                </form>
              </div>
            </div>
          </div>
        </div>
      </div>
    </div>
  </div>
</template>

<script>
import axios from "axios";

export default {
  data() {
    return {
      color: ["none", "cyan", "yellow", "green", "orange", "red", "red"],

      convertStatus: [
        "0",
        "Criado",
        "Em bancada",
        "Orçamento Enviado",
        "Orçamento Aprovado",
        "Orçamento Reprovado",
        "Não Aprovado, aguardando retirada",
        "Aprovado, aguardando retirada",
        "Aprovado, retirado",
        "Não Aprovado, retirado",
        "Pago, Aguardando retirada",
        "desconhecido",
      ],
      btnOr: [true,true,true,false,false,false,false,false,false,false,false,false],
      btnFin:[false,false,false,false,true,true,false,false,false,false,false,false],
      showOrder: true,
      showOrderRepair: false,
      qtd: "",
      stringBusca: "",
      desc: "",
      orderValue: 0,
      componentes: null,
      componente: {
        id: null,
        descricao: null,
        valorComponente: 0,
        quantidade: null,
      },
      chamados: null,
      chamado: {
        id: null,
        defRelatado: null,
        defApresentado: null,
        valor: 0,
        status: null,
        componentsJson: [],
      },
      componenteAdj: {
        qtd: null,
      },
    };
  },
  methods: {
    listar() {
      axios
        .get(this.$MainURL + "/chamados", {
          headers: {
            Authorization: `Bearer ${localStorage.getItem("token")}`,
          },
        })
        .then((response) => (this.chamados = response.data));
    },

    searchComponent(desc) {
      axios
        .get(this.$MainURL + "/componentes/" + desc, {
          headers: {
            Authorization: `Bearer ${localStorage.getItem("token")}`,
          },
        })
        .then((response) => (this.componentes = response.data));
    },

    addComponent(id) {
      axios
        .get(this.$MainURL + "/componentes/" + id, {
          headers: {
            Authorization: `Bearer ${localStorage.getItem("token")}`,
          },
        })
        .then((response) => {
          this.componente = response.data;
          if (
            this.chamado.componentsJson.find((t) => t.id == this.componente.id)
          )
            alert("ja adicionado");
          else {
            this.chamado.componentsJson.push({
              id: this.componente.id,
              descricao: this.componente.descricao,
              valor: this.componente.valorComponente,
              valorTotal: this.componente.valorComponente,
              qtd: 1,
              quantidade: this.componente.quantidade - 1,
            });
            this.sumValue(1, this.componente.id);
          }
        });
    },

    sumValue(qtd, id) {
      this.chamado.componentsJson.find((t) => t.id == id).valorTotal = (
        qtd * this.chamado.componentsJson.find((t) => t.id == id).valor
      ).toFixed(2);
      this.chamado.componentsJson.find((t) => t.id == id).quantidade =
        this.componente.quantidade - qtd;

      if (qtd == "0") {
        alert("removido");
        this.chamado.componentsJson = this.chamado.componentsJson.filter(
          function (obj) {
            return obj.id !== id;
          }
        );
      }

      this.sumOrder();
    },

    sumOrder() {
      var valores = [];
      if (this.chamado.componentsJson.length) {
        this.chamado.componentsJson.map((x) => {
          valores.push(x.valorTotal);
        });
        var soma = valores.reduce((a, b) => {
          return parseFloat(a) + parseFloat(b);
        });

        this.chamado.valor = (
          parseFloat(soma) + parseFloat(this.orderValue)
        ).toFixed(2);
      } else {
        this.chamado.valor = parseFloat(this.orderValue).toFixed(2);
      }
    },

    syncOrderValue() {
      var soma = 0;
      if (!this.chamado.valor) {
        this.orderValue = 0;
      }
      var valores = [];
      this.chamado.componentsJson.map((x) => {
        valores.push(x.valorTotal);
      });
      console.log(valores);
      if (valores.length) {
        soma = valores.reduce((a, b) => {
          return parseFloat(a) + parseFloat(b);
        });
        this.orderValue = (
          parseFloat(this.chamado.valor) - parseFloat(soma)
        ).toFixed(2);
      } else {
        this.orderValue = 0;
      }
    },

    buscar(nome) {
      if (!nome) {
        this.listar();
      } else {
        axios
          .get(this.$MainURL + "/chamados/" + nome, {
            headers: {
              Authorization: `Bearer ${localStorage.getItem("token")}`,
            },
          })
          .then((response) => (this.chamados = response.data));
      }
    },
    async removeComponent() {
      console.log("aqui");
      for (const obj of this.chamado.componentsJson) {
        // para cada elemento do array, imprime o nome
        console.log(`id=${obj.id}`);
        console.log(`QTD=${obj.qtd}`);
        this.componenteAdj.qtd = obj.quantidade;
        console.log(this.componenteAdj.qtd);
        await axios.put(
          this.$MainURL + "/componentesQtd/" + obj.id,
          this.componenteAdj
        );
      }
    },
    salvar() {
      if (this.chamado.status == 2) this.removeComponent();
      switch (parseInt(this.chamado.status)) {
        case 1:
          // "Criado"
          this.chamado.status = 2;
          break;
        case 2:
          // "Em bancada"
          this.chamado.status = 3;
          break;
        case 3:
          // "Orçamento Enviado"
          this.chamado.status = 3;
          break;
        case 4:
          // "Orçamento Aprovado"
          this.chamado.status = 7;
          break;
        case 5:
          //"Orçamento Reprovado"
          this.chamado.status = 6;
          break;
        case 6:
          //  "Não Aprovado, aguardando retirada"
          this.chamado.status = 6;
          break;
        case 7:
          //   "Aprovado, aguardando retirada"
          this.chamado.status = 7;
          break;
        case 8:
          //  "Aprovado, retirado"
          this.chamado.status = 8;
          break;
        case 9:
          //  "Não Aprovado, retirado"
          this.chamado.status = 9;
          break;
        case 10:
          // "Pago, Aguardando retirada"
          this.chamado.status = 10;
          break;
        default:
          //  "desconhecido"
          this.chamado.status = 11;
      }

      if (this.chamado.id) {
        axios
          .put(
            this.$MainURL + "/homeTecnico/" + this.chamado.id,
            this.chamado,
            {
              headers: {
                Authorization: `Bearer ${localStorage.getItem("token")}`,
              },
            }
          )
          // eslint-disable-next-line no-unused-vars
          .then((response) => {
            alert(`Ok, Alterado com sucesso`);
            this.listar();
            this.chamado = {};
          });
      } else {
        axios
          .post(this.$MainURL + "/chamados", this.chamado, {
            headers: {
              Authorization: `Bearer ${localStorage.getItem("token")}`,
            },
          })
          .then((response) => {
            alert(`Ok, cadastrado com ID: ${response.data.id}`);
            this.listar();
            this.chamado = {};
          });
      }
    },

    editar(id) {
      axios
        .get(this.$MainURL + "/chamados/" + id, {
          headers: {
            Authorization: `Bearer ${localStorage.getItem("token")}`,
          },
        })
        .then((response) => {
          (this.chamado = response.data),
            (this.showOrder = false),
            (this.showOrderRepair = true);

          switch (parseInt(this.chamado.status)) {
            case 1:
              // "Criado"
              this.chamado.status = 2;
              break;
            case 2:
              // "Em bancada"
              this.chamado.status = 2;
              break;
            case 3:
              // "Orçamento Enviado"
              this.chamado.status = 3;
              break;
            case 4:
              // "Orçamento Aprovado"
              this.chamado.status = 4;
              break;
            case 5:
              // "Orçamento Reprovado"
              this.chamado.status = 5;
              break;
            case 6:
              //  "Aprovado, em bancada"
              this.chamado.status = 6;
              break;
            case 7:
              //  "Aguardando retirada"
              this.chamado.status = 7;
              break;
            case 8:
              //  "Pago, retirado"
              this.chamado.status = 8;
              break;
            case 9:
              //  "Não Pago, retirado"
              this.chamado.status = 9;
              break;
            case 10:
              // "Pago, Aguardando retirada"
              this.chamado.status = 10;
              break;
            default:
              //  "desconhecido"
              this.chamado.status = 11;
          }
          axios
            .put(
              this.$MainURL + "/homeTecnico/" + this.chamado.id,
              this.chamado,
              {
                headers: {
                  Authorization: `Bearer ${localStorage.getItem("token")}`,
                },
              }
            )
            // eslint-disable-next-line no-unused-vars
            .then((response) => {
              this.listar();
            });
          if (this.chamado.componentsJson) this.syncOrderValue();
        });
    },

    turnBack() {
      this.showOrder = true;
      this.showOrderRepair = false;
    },

    excluir(id, cod) {
      if (confirm(`Confirma exclusão do filme '${cod}`));

      axios
        .delete(this.$MainURL + "/chamados/" + id, {
          headers: {
            Authorization: `Bearer ${localStorage.getItem("token")}`,
          },
        })
        // eslint-disable-next-line no-unused-vars
        .then((response) => {
          alert(`chamado '${cod}' excluido com sucesso`);
          this.listar();
        });
    },
  },

  mounted() {
    this.listar();
  },
};
</script>

<style scoped></style>
